/*
 *	clipflt.c
 *
 *	Px_ZCu
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2008 Naoyuki Sawa
 *
 *	* Sun Jul 20 13:26:33 JST 2008 Naoyuki Sawa
 *	- 쐬JnB
 *	* Sun Jul 20 19:20:18 JST 2008 Naoyuki Sawa
 *	- matf_rot()ŁAāA{xłsin()Acos()ĂяoĂ܂Ă܂B
 *	  ̂߁Amatf_rot()gpƁA傫Ȑ\ቺƂȂĂ܂Ă܂B
 *	  APxłsinf()Acosf()Ăяo悤AC܂B
 */
#include "clip.h"

#ifndef PIECE
#define NOASM	// ̃V|`ƁACłgp܂B */
#endif /*PIECE*/

/****************************************************************************
 *	Œ菬_{xNg,s}̕_{xNg,s}
 ****************************************************************************/

#ifdef NOASM
void vecf_conv(vecf* vec1, const vecx* vec2) {
	      float* dst = &vec1->x;
	const fixed* src = &vec2->x;
	int cnt = 3;
	do {
		*dst++ = fst(*src++);
	} while(--cnt);
}
void matf_conv(matf* mat1, const matx* mat2) {
	      float* dst = &mat1->a00;
	const fixed* src = &mat2->a00;
	int cnt = 12;
	do {
		*dst++ = fst(*src++);
	} while(--cnt);
}
#else /*NOASM*/
asm("
		.code
		.align		1
		.global		vecf_conv
		.global		matf_conv
vecf_conv:	;---------------------------------------;
		jp.d		vecf_matf_conv
		ld.w		%r4, 3			; %r4  := cnt = 3					*delay*
matf_conv:	;---------------------------------------;
		ld.w		%r4, 12			; %r4  := cnt = 12
vecf_matf_conv:	;---------------------------------------;
		ld.w		%r5, %r12		; %r5  := (float*)dst
		ld.w		%r6, %r13		; %r6  := (fixed*)src
		xld.w		%r7, 0x3a800000		; %r7  := (1.0f / 1024.0f)
vecf_matf_conv_loop:
		ld.w		%r12, [%r6]+		; %r12 := x = (fixed)*src++
		xcall		__floatsisf		; %r10 := f = (float)x
		;//
		ld.w		%r12, %r10		; %r12 := f
		xcall.d		__mulsf3		; %r10 := f *= (1.0f / 1024.0f)
		ld.w		%r13, %r7		; %r13 :=      (1.0f / 1024.0f)				*delay*
		;//
		ld.w		[%r5]+, %r10		; *dst++ = f
		sub		%r4, 1			; %r4  := cnt--
		jrne		vecf_matf_conv_loop
		ret
");
#endif /*NOASM*/

/*--------------------------------------------------------------------------*/

#ifdef NOASM
void matx_conv(matx* mat1, const matf* mat2) {
	      fixed* dst = &mat1->a00;
	const float* src = &mat2->a00;
	int cnt = 12;
	do {
		*dst++ = fld(*src++);
	} while(--cnt);
}
void vecx_conv(vecx* vec1, const vecf* vec2) {
	      fixed* dst = &vec1->x;
	const float* src = &vec2->x;
	int cnt = 3;
	do {
		*dst++ = fld(*src++);
	} while(--cnt);
}
#else /*NOASM*/
asm("
		.code
		.align		1
		.global		vecx_conv
		.global		matx_conv
vecx_conv:	;---------------------------------------;
		jp.d		vecx_matx_conv
		ld.w		%r4, 3			; %r4  := cnt = 3					*delay*
matx_conv:	;---------------------------------------;
		ld.w		%r4, 12			; %r4  := cnt = 12
vecx_matx_conv:	;---------------------------------------;
		ld.w		%r5, %r12		; %r5  := (fixed*)dst
		ld.w		%r6, %r13		; %r6  := (float*)src
		xld.w		%r7, 0x44800000		; %r7  := 1024.0f
vecx_matx_conv_loop:
		ld.w		%r12, [%r6]+		; %r12 := f = (float)*src++
		xcall.d		__mulsf3		; %r10 := f *= 1024.0f
		ld.w		%r13, %r7		; %r13 :=      1024.0f					*delay*
		;//
		xcall.d		__fixsfsi		; %r10 := x = (fixed)f
		ld.w		%r12, %r10		; %r12 := x						*delay*
		;//
		ld.w		[%r5]+, %r10		; *dst++ = f
		sub		%r4, 1			; %r4  := cnt--
		jrne		vecx_matx_conv_loop
		ret
");
#endif /*NOASM*/

/****************************************************************************
 *	_xNg
 ****************************************************************************/

const vecf vecf_0 = { 0.0f, 0.0f, 0.0f };
const vecf vecf_1 = { 1.0f, 1.0f, 1.0f };
const vecf vecf_x = { 1.0f, 0.0f, 0.0f };
const vecf vecf_y = { 0.0f, 1.0f, 0.0f };
const vecf vecf_z = { 0.0f, 0.0f, 1.0f };

/*--------------------------------------------------------------------------*/

#ifdef NOASM
void vecf_add(vecf* vec1, const vecf* vec2) {
	vec1->x += vec2->x;
	vec1->y += vec2->y;
	vec1->z += vec2->z;
}
void vecf_sub(vecf* vec1, const vecf* vec2) {
	vec1->x -= vec2->x;
	vec1->y -= vec2->y;
	vec1->z -= vec2->z;
}
void vecf_mul(vecf* vec1, const vecf* vec2) {
	vec1->x *= vec2->x;
	vec1->y *= vec2->y;
	vec1->z *= vec2->z;
}
void vecf_div(vecf* vec1, const vecf* vec2) {
	vec1->x /= vec2->x;
	vec1->y /= vec2->y;
	vec1->z /= vec2->z;
}
void vecf_neg(vecf* vec) {
	vec->x = -vec->x;
	vec->y = -vec->y;
	vec->z = -vec->z;
}
#else /*NOASM*/
asm("
		.code
		.align		1
		.global		vecf_add
		.global		vecf_sub
		.global		vecf_mul
		.global		vecf_div
		.global		vecf_neg
vecf_neg:
		xld.w		%r4, __negsf2
		jp.d		vecf_op
		ld.w		%r13, %r12		; vec2̓_~[̓ǂݍ݂ɂȂ܂B			*delay*
		;---------------------------------------;
vecf_div:
		xld.w		%r4, __divsf3
		jp		vecf_op
		;---------------------------------------;
vecf_mul:
		xld.w		%r4, __mulsf3
		jp		vecf_op
		;---------------------------------------;
vecf_sub:
		xld.w		%r4, __subsf3
		jp		vecf_op
		;---------------------------------------;
vecf_add:
		xld.w		%r4, __addsf3
		;---------------------------------------;
vecf_op:
		ld.w		%r5, %r12		; %r5  := vec1
		ld.w		%r6, %r13		; %r6  := vec2
		ld.w		%r7, 3			; %r7  := cnt
vecf_op_loop:
		ld.w		%r12, [%r5]		; %r12 := vec1->x
		ld.w		%r13, [%r6]+		; %r13 :=           vec2->x
		call		%r4			; %r10 := vec1->x + vec2->x
		ld.w		[%r5]+, %r10
		sub		%r7, 1			; %r7  := cnt--
		jrne		vecf_op_loop
		ret
");
#endif /*NOASM*/

/*--------------------------------------------------------------------------*/

#ifdef NOASM
void vecf_normal(vecf* vec) {
	float mag = vecf_mag(vec);
	vec->x /= mag;
	vec->y /= mag;
	vec->z /= mag;
}
#else /*NOASM*/
asm("
		.code
		.align		1
		.global		vecf_normal
vecf_normal:
		xsub		%sp, %sp, 12
		xld.w		[%sp+0], %r12		; [%sp+0] := vec
		xcall		vecf_mag		; %r10    := mag
		xld.w		%r12, [%sp+0]		; %r12    := vec
		xld.w		[%sp+0], %r10
		xld.w		[%sp+4], %r10
		xld.w		[%sp+8], %r10
		ld.w		%r13, %sp		; %r13    :=       [mag,mag,mag]
		xcall		vecf_div		; %r10    := vec / [mag,mag,mag]
		xadd		%sp, %sp, 12
		ret
");
#endif /*NOASM*/

/*--------------------------------------------------------------------------*/

#ifdef NOASM
float vecf_mag(const vecf* vec) {
	return sqrtf(vecf_mag2(vec));
}
float vecf_mag2(const vecf* vec) {
	return vecf_dot(vec, vec);
}
float vecf_dot(const vecf* vec1, const vecf* vec2) {
	return (vec1->x * vec2->x) + (vec1->y * vec2->y) + (vec1->z * vec2->z);
}
#else /*NOASM*/
asm("
		.code
		.align		1
		.global		vecf_mag
		.global		vecf_mag2
		.global		vecf_dot
vecf_mag:
		call		vecf_mag2
		xjp.d		sqrtf
		ld.w		%r12, %r10		;							*delay*
		;---------------------------------------;
vecf_mag2:
		ld.w		%r13, %r12
		;---------------------------------------;
vecf_dot:
		ld.w		%r4, %r12		; %r4  := vec1
		ld.w		%r5, %r13		; %r5  := vec2
		ld.w		%r6, 3			; %r6  := cnt
		ld.w		%r7, 0			; %r7  := sum
vecf_dot_loop:
		ld.w		%r12, [%r4]+		; %r12 := vec1->x
		ld.w		%r13, [%r5]+		; %r13 :=           vec2->x
		xcall		__mulsf3		; %r10 := vec1->x * vec2->x
		ld.w		%r12, %r10		; %r13 := vec1->x * vec2->x
		xcall.d		__addsf3		; %r10 := vec1->x * vec2->x + sum
		ld.w		%r13, %r7		; %r12 :=                     sum			*delay*
		sub		%r6, 1			; %r6  := cnt--
		jrne.d		vecf_dot_loop
		ld.w		%r7, %r10		; %r7  := sum						*delay*
		ret.d
		ld.w		%r10, %r7		; %r10 := sum						*delay*
");
#endif /*NOASM*/

/*--------------------------------------------------------------------------*/

#ifdef NOASM
vecf vecf_cross(const vecf* vec1, const vecf* vec2) {
	vecf tmp;
	tmp.x = (vec1->y * vec2->z) - (vec1->z * vec2->y);
	tmp.y = (vec1->z * vec2->x) - (vec1->x * vec2->z);
	tmp.z = (vec1->x * vec2->y) - (vec1->y * vec2->x);
	return tmp;
}
#else /*NOASM*/
asm("
		.code
		.align		1
		.global		vecf_cross
vecf_cross:
		pushn		%r3
		ld.w		%r0, %r12		; %r0  := ʂi[\̂̃AhX
		ld.w		%r1, [%r13]+		; %r1  := vec1->x
		ld.w		%r2, [%r13]+		; %r2  := vec1->y
		ld.w		%r3, [%r13]		; %r3  := vec1->z
		ld.w		%r4, [%r14]+		; %r4  := vec2->x
		ld.w		%r5, [%r14]+		; %r5  := vec2->y
		ld.w		%r6, [%r14]		; %r6  := vec2->z
		;//
		ld.w		%r12, %r2		; %r12 := vec1->y
		xcall.d		__mulsf3		; %r10 := vec1->y * vec2->z
		ld.w		%r13, %r6		; %r13 :=           vec2->z				*delay*
		ld.w		%r7, %r10		; %r7  := vec1->y * vec2->z
		ld.w		%r12, %r3		; %r12 :=                     vec1->z
		xcall.d		__mulsf3		; %r10 :=                     vec1->z * vec2->y
		ld.w		%r13, %r5		; %r13 :=                               vec2->y		*delay*
		ld.w		%r12, %r7		; %r12 := vec1->y * vec2->z
		xcall.d		__subsf3		; %r10 := vec1->y * vec2->z - vec1->z * vec2->y
		ld.w		%r13, %r10		; %r13 :=                     vec1->z * vec2->y		*delay*
		ld.w		[%r0]+, %r10
		;//
		ld.w		%r12, %r3		; %r12 := vec1->z
		xcall.d		__mulsf3		; %r10 := vec1->z * vec2->x
		ld.w		%r13, %r4		; %r13 :=           vec2->x				*delay*
		ld.w		%r7, %r10		; %r7  := vec1->z * vec2->x
		ld.w		%r12, %r1		; %r12 :=                     vec1->x
		xcall.d		__mulsf3		; %r10 :=                     vec1->x * vec2->z
		ld.w		%r13, %r6		; %r13 :=                               vec2->z		*delay*
		ld.w		%r12, %r7		; %r12 := vec1->z * vec2->x
		xcall.d		__subsf3		; %r10 := vec1->z * vec2->x - vec1->x * vec2->z
		ld.w		%r13, %r10		; %r13 :=                     vec1->x * vec2->z		*delay*
		ld.w		[%r0]+, %r10
		;//
		ld.w		%r12, %r1		; %r12 := vec1->x
		xcall.d		__mulsf3		; %r10 := vec1->x * vec2->y
		ld.w		%r13, %r5		; %r13 :=           vec2->y				*delay*
		ld.w		%r7, %r10		; %r7  := vec1->x * vec2->y
		ld.w		%r12, %r2		; %r12 :=                     vec1->y
		xcall.d		__mulsf3		; %r10 :=                     vec1->y * vec2->x
		ld.w		%r13, %r4		; %r13 :=                               vec2->x		*delay*
		ld.w		%r12, %r7		; %r12 := vec1->x * vec2->y
		xcall.d		__subsf3		; %r10 := vec1->x * vec2->y - vec1->y * vec2->x
		ld.w		%r13, %r10		; %r13 :=                     vec1->y * vec2->x		*delay*
		ld.w		[%r0]+, %r10
		;//
		ld.w		%r10, %r0		; %r10 := ʂi[\̂̃AhX + 12
		popn		%r3
		ret.d
		sub		%r10, 12		; %r10 := ʂi[\̂̃AhX		*delay*
");
#endif /*NOASM*/

/****************************************************************************
 *	_s
 ****************************************************************************/

const matf matf_0 = {
	0.0f, 0.0f, 0.0f, 0.0f,
	0.0f, 0.0f, 0.0f, 0.0f,
	0.0f, 0.0f, 0.0f, 0.0f,
};
const matf matf_1 = {
	1.0f, 0.0f, 0.0f, 0.0f,
	0.0f, 1.0f, 0.0f, 0.0f,
	0.0f, 0.0f, 1.0f, 0.0f,
};

/*--------------------------------------------------------------------------*/

void matf_xlate(matf* mat, float x, float y, float z) {
	matf tmp = {
		1.0f, 0.0f, 0.0f, x,
		0.0f, 1.0f, 0.0f, y,
		0.0f, 0.0f, 1.0f, z,
	};
	matf_xform(mat, &tmp);
}

/*--------------------------------------------------------------------------*/

void matf_scale(matf* mat, float x, float y, float z) {
	matf tmp = {
		   x, 0.0f, 0.0f, 0.0f,
		0.0f,    y, 0.0f, 0.0f,
		0.0f, 0.0f,    z, 0.0f,
	};
	matf_xform(mat, &tmp);
}

/*--------------------------------------------------------------------------*/

void matf_rot(matf* mat, const vecf* axis, float ang) {
	float s = sinf(ang);
	float c = cosf(ang);
	float ic = 1.0f - c;
	vecf _axis = *axis;
	vecf_normal(&_axis);
	{
		matf tmp = {
			(_axis.x * _axis.x * ic) + (          c), (_axis.x * _axis.y * ic) - (_axis.z * s), (_axis.x * _axis.z * ic) + (_axis.y * s), 0.0f,
			(_axis.y * _axis.x * ic) + (_axis.z * s), (_axis.y * _axis.y * ic) + (          c), (_axis.y * _axis.z * ic) - (_axis.x * s), 0.0f,
			(_axis.z * _axis.x * ic) - (_axis.y * s), (_axis.z * _axis.y * ic) + (_axis.x * s), (_axis.z * _axis.z * ic) + (          c), 0.0f,
		};
		matf_xform(mat, &tmp);
	}
}

/*--------------------------------------------------------------------------*/

void matf_rotx(matf* mat, float ang) {
	float s = sinf(ang);
	float c = cosf(ang);
	matf tmp = {
		1.0f, 0.0f, 0.0f, 0.0f,
		0.0f,    c,   -s, 0.0f,
		0.0f,    s,    c, 0.0f,
	};
	matf_xform(mat, &tmp);
}

/*--------------------------------------------------------------------------*/

void matf_roty(matf* mat, float ang) {
	float s = sinf(ang);
	float c = cosf(ang);
	matf tmp = {
		   c, 0.0f,    s, 0.0f,
		0.0f, 1.0f, 0.0f, 0.0f,
		  -s, 0.0f,    c, 0.0f,
	};
	matf_xform(mat, &tmp);
}

/*--------------------------------------------------------------------------*/

void matf_rotz(matf* mat, float ang) {
	float s = sinf(ang);
	float c = cosf(ang);
	matf tmp = {
		   c,   -s, 0.0f, 0.0f,
		   s,    c, 0.0f, 0.0f,
		0.0f, 0.0f, 1.0f, 0.0f,
	};
	matf_xform(mat, &tmp);
}

/*--------------------------------------------------------------------------*/

void matf_invno(matf* mat) {
	matf tmp = {
		mat->a00, mat->a10, mat->a20, -((mat->a00 * mat->a03) + (mat->a10 * mat->a13) + (mat->a20 * mat->a23)),
		mat->a01, mat->a11, mat->a21, -((mat->a01 * mat->a03) + (mat->a11 * mat->a13) + (mat->a21 * mat->a23)),
		mat->a02, mat->a12, mat->a22, -((mat->a02 * mat->a03) + (mat->a12 * mat->a13) + (mat->a22 * mat->a23)),
	};
	*mat = tmp;
}

/*--------------------------------------------------------------------------*/

void matf_orient(matf* mat, const vecf* forward, const vecf* up) {
	vecf _forward;
	vecf _right;
	vecf _up;
	_forward = *forward;
	vecf_normal(&_forward);
	_right = vecf_cross(up, &_forward);
	vecf_normal(&_right);
	_up = vecf_cross(&_forward, &_right);
	{
		matf tmp = {
			_right.x, _up.x, _forward.x, 0.0f,
			_right.y, _up.y, _forward.y, 0.0f,
			_right.z, _up.z, _forward.z, 0.0f,
		};
		matf_xform(mat, &tmp);
	}
}

/*--------------------------------------------------------------------------*/

void matf_lookat(matf* mat, const vecf* eye, const vecf* center, float ang) {
	vecf forward;
	matf tmp = matf_1;
	matf_xlate(&tmp, eye->x, eye->y, eye->z);
	forward = *center;
	vecf_sub(&forward, eye);
	matf_orient(&tmp, &forward, &vecf_y);
	matf_rotz(&tmp, ang);
	matf_invno(&tmp);
	matf_xform(mat, &tmp);
}

/*--------------------------------------------------------------------------*/

void matf_frustum(matf* mat, float width, float height, float front) {
	matf tmp = {
		2.0f * front / width,                  0.0f, 0.0f, 0.0f,
		                0.0f, 2.0f * front / height, 0.0f, 0.0f,
		                0.0f,                  0.0f, 1.0f, 0.0f,
	};
	matf_xform(mat, &tmp);
}

/*--------------------------------------------------------------------------*/

void matf_perspect(matf* mat, float fovy, float aspect, float front) {
	float height = front * tanf(fovy / 2.0f) * 2.0f;
	float width = height * aspect;
	matf_frustum(mat, width, height, front);
}

/*--------------------------------------------------------------------------*/

void matf_viewportz(matf* mat, int left, int top, int width, int height) {
	matf tmp = {
		width / 2.0f,           0.0f, left + width / 2.0f, 0.0f,
		        0.0f, -height / 2.0f, top + height / 2.0f, 0.0f,
		        0.0f,           0.0f,                1.0f, 0.0f,
	};
	matf_xform(mat, &tmp);
}

/****************************************************************************
 *	
 ****************************************************************************/

