/*
 *	clipflt.h
 *
 *	Px_ZCu
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2008 Naoyuki Sawa
 *
 *	* Sat Jun 21 22:52:08 JST 2008 Naoyuki Sawa
 *	- 쐬JnB
 *	* Thu Jun 26 01:31:00 JST 2008 Naoyuki Sawa
 *	- C99̒Pxł̕W֐ɂẴRgǋL܂B
 *	* Sun Jun 29 15:18:06 JST 2008 Naoyuki Sawa
 *	- Px_̊{ZTu[`A%r4,%r5,%r6,%r7̒lύXȂƂAdlƂ܂B
 *	* Sun Jul 20 13:26:33 JST 2008 Naoyuki Sawa
 *	- _xNgA_s̍\̂ƁA֐ǉ܂B
 *	  keep/01_ŉZ`R[hۑ/clipmath.cW[Qlɂ܂B
 *	  _ZxČŒ菬_Zֈڍs킯łAĂѕ_Zɖ߂킯łB
 *	- éAkeep/01_ŉZ`R[hۑ/clipmath.cAсAclipfix.cƂقړȂ̂ŁA܂RgĂ܂B
 *	  keep/01_ŉZ`R[hۑ/clipmath.cAсAclipfix.c̃RgQlɂĉB
 *	  ܂Aclipfix.cɎǁAقƂǎgpȂ@\ɂẮA{W[ł͖ƂĂ܂B(matf_rotxyx()Ȃ)
 *	- RAMւ̔zúAɎgppxƗ\zAvecf_xform()matf_xform()Aframflt3.cɕ܂B
 */
#ifndef __CLIP_FLT_H__
#define __CLIP_FLT_H__

/*****************************************************************************
 *	萔E}N
 *****************************************************************************/

typedef union _FLT_INT {
	struct {
		unsigned m : 23;	/* mantissa */
		unsigned e :  8;	/* exponent */
		unsigned s :  1;	/* sign */
	} i;
	float f;
} FLT_INT;

/*****************************************************************************
 *	EPSONŕ_ZCu(fp.lib)̓[`u
 *****************************************************************************/

//d@v
//* Sun Jun 29 15:18:06 JST 2008 Naoyuki Sawa                                                                                         
//- {W[Œ`ĂAPx_̊{ZTu[`́AׂāA%r4,%r5,%r6,%r7̒lύX܂B             
//  S1C33 ABIdlɏ]Ēlێ%r0,%r1,%r2,%r3ɉāA%r4,%r5,%r6,%r7̒lێ܂B                                       
//  ĂяovÓA%r0,%r1,%r2,%r3,%r4,%r5,%r6,%r7̒lύXȂƂOɁAWX^gpœKł܂B             
//- {ZTu[`ɂẮA݂̎ł%r14%r15̒lێĂ̂L܂A̎ύXɂĕۏ؂܂B
//  ĂяovÓA%r0,%r1,%r2,%r3,%r4,%r5,%r6,%r7ȊO̒lύXȂƂOƂāA쐬ȂłB             
//

float __addsf3(float x, float y);	/* float + float ->     float */
float __subsf3(float x, float y);	/* float - float ->     float */
float __mulsf3(float x, float y);	/* float * float ->     float */
float __divsf3(float x, float y);	/* float / float ->     float */
float __negsf2(float x, float y);	/*       - float ->     float */
int __fixsfsi(float x);			/*         float ->       int */
unsigned __fixunssfsi(float x);		/*         float ->  unsigned */
float __floatsisf(int x);		/*           int ->     float */
float __truncdfsf2(double x);		/*        double ->     float */
double __extendsfdf2(float x);		/*         float ->    double */
void __fcmps(float x, float y);		/* float - float -> condition */

/*****************************************************************************
 *	ANSICuw֐(math.lib)Ɨގ̋@\̒Px
 *****************************************************************************/

/* * Thu Jun 26 01:31:00 JST 2008 Naoyuki Sawa
 * - C99ɂ́APxł̕W֐߂Ă邻łB(sqrtf()Ȃ)
 *   ȉ̊֐́AC99̒Pxł̕W֐ƂقړdlƎv܂A
 *   C99̊֐dlǂmȂ̂ŁAŜߕʂ̖OɂĂ܂B
 *   AC99̒Pxł̕W֐̎dlɈv邱ƂmFłۂɁA
 *   sqrtffloat_sqrt#defineAȂǂ̕@őΉ悤Ǝv܂B
 * * Sat Jul 12 22:49:09 JST 2008 Naoyuki Sawa
 * - C99̊֐ɕύX܂B(float_sqrtsqrtfȂ)
 *   #defineőΉ悤ƂvĂ܂Aς芮Sɏ邱Ƃɂ܂B
 *   #defineł́AAZu[`gƂɁA̖OłĂяoȂłB
 * - Suŕϊ̂ŁAȑÕR[hRgASC99̊֐ɂȂĂ܂B
 *   Afloat_*()`̖O͂ǂɂcĂȂ̂ŁAYĂ܂Č\łB
 */

float sqrtf(float x);
float modff(float x, float* intptr);
float fmodf(float x, float y);
float cosf(float x);
float sinf(float x);
float tanf(float x);
float atanf(float x);
float atan2f(float y, float x);
float expf(float x);
float ldexpf(float x, int exp);
float frexpf(float x, int* expptr);
float logf(float x);
float floorf(float x);
float ceilf(float x);
float fabsf(float x);

/****************************************************************************
 *	Œ菬_{xNg,s}̕_{xNg,s}
 ****************************************************************************/

typedef struct _vecf vecf;
typedef struct _matf matf;

typedef vector vecx;	/* clipfix.h */
typedef matrix matx;	/* clipfix.h */

void vecf_conv(vecf* vec1, const vecx* vec2);
void vecx_conv(vecx* vec1, const vecf* vec2);

void matf_conv(matf* mat1, const matx* mat2);
void matx_conv(matx* mat1, const matf* mat2);

/****************************************************************************
 *	_xNg
 ****************************************************************************/

/*typedef*/ struct _vecf {
	float x, y, z;
} /*vecf*/;

/*--------------------------------------------------------------------------*/

extern const vecf vecf_0;
extern const vecf vecf_1;
extern const vecf vecf_x;
extern const vecf vecf_y;
extern const vecf vecf_z;

/*--------------------------------------------------------------------------*/

void vecf_xform(const matf* mat, vecf* vec);	/* s|āAẼxNgϊ܂B */

void vecf_add(vecf* vec1, const vecf* vec2);
void vecf_sub(vecf* vec1, const vecf* vec2);
void vecf_mul(vecf* vec1, const vecf* vec2);
void vecf_div(vecf* vec1, const vecf* vec2);

void vecf_neg(vecf* vec);
void vecf_normal(vecf* vec);

float vecf_mag(const vecf* vec);
float vecf_mag2(const vecf* vec);
float vecf_dot(const vecf* vec1, const vecf* vec2);
vecf vecf_cross(const vecf* vec1, const vecf* vec2);

//void vecf_reflect(vecf* vec, const vecf* normal);
//2008/07/20: Ƃ́Avreflect()Ƃ͌xNg̎w̕tɂ\łB
//  vreflect()͋ťxNgŎw肵Ă܂A̕RƎvłB

/****************************************************************************
 *	_s
 ****************************************************************************/

/*typedef*/ struct _matf {
	/*     +----------------- pxNgx */
	/*     |    +------------ pxNgy */
	/*     |    |    +------- pxNgz */
	/*     |    |    |    +-- sړ        */
	float a00, a01, a02, a03;
	float a10, a11, a12, a13;
	float a20, a21, a22, a23;
} /*matf*/;

/*--------------------------------------------------------------------------*/

extern const matf matf_0;
extern const matf matf_1;

/*--------------------------------------------------------------------------*/

void matf_xform(matf* mat1, const matf* mat2);	/* Es|āA̍sϊ܂B */

void matf_xlate(matf* mat, float x, float y, float z);
void matf_scale(matf* mat, float x, float y, float z);
void matf_rot(matf* mat, const vecf* axis, float ang);
void matf_rotx(matf* mat, float ang);
void matf_roty(matf* mat, float ang);
void matf_rotz(matf* mat, float ang);
//void matf_rotxyx(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotxzx(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotyxy(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotyzy(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotzxz(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotzyz(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotxyz(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotxzy(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotyxz(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotyzx(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotzxy(matf* mat, float ang1, float ang2, float ang3);
//void matf_rotzyx(matf* mat, float ang1, float ang2, float ang3);
//float matf_rotget(const matf* mat, vecf* axis);

//void matf_xpose(matf* mat);
//void matf_inv(matf* mat);
void matf_invno(matf* mat);

void matf_orient(matf* mat, const vecf* forward, const vecf* up);
void matf_lookat(matf* mat, const vecf* eye, const vecf* center, float ang);

void matf_frustum(matf* mat, float width, float height, float front);
void matf_perspect(matf* mat, float fovy, float aspect, float front);

//void matf_viewport(matf* mat, int left, int top, int width, int height);
void matf_viewportz(matf* mat, int left, int top, int width, int height);

//void matf_shadow(matf* mat, const vecf* light, const vecf* ground, const vecf* normal);

/*****************************************************************************
 *	
 *****************************************************************************/

#endif /*__CLIP_FLT_H__*/
