/*
 *	main.c
 *
 *	3D Benchǂ
 *
 *	* Thu Feb 07 23:15:58 JST 2008 Naoyuki Sawa
 *	- 1st [XB
 *	* Sun Apr 06 22:46:42 JST 2008 Naoyuki Sawa
 *	- ɂ30FPSȏo悤ɂȂ̂ŁA30FPS̃~b^O܂B
 *	* Mon Jul 21 13:58:55 JST 2008 Naoyuki Sawa
 *	- LN^̈ړ]Ȃǂ́As񉉎ZA_ɂĂ݂܂B
 *	  `揈̒_WϊȂǂ́AŒ菬_̂܂܂łB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SOUND
const void* sound_table[SOUND_COUNT];
#endif /*USE_SOUND*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef REPEAT_PAD
	pad_set_repeat(REPEAT_PAD, REPEAT_DELAY, REPEAT_INTERVAL);
#endif /*REPEAT_PAD*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef RESOURCE_FNAME
	/* pext@CYt\[X擾܂B */
	resource = resource_address(RESOURCE_FNAME);
#endif /*RESOURCE_FNAME*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_DBG
	/* DBGjbgݒ肵܂B */
	dbg_init();
#endif /*USE_DBG*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

#ifdef USE_2BIT_ADPCM
	/* 2-bit ADPCM DecoderN܂B */
	adpcm_init(ADPCM_CHANNELS);
#endif /*USE_2BIT_ADPCM*/

	/* TEh܂B */
#ifdef USE_SOUND
	{
#define SOUND_(name) { extern const unsigned char name[]; sound_table[SND_##name] = name; }
#define SOUND_RESOURCE_(name,fname) { sound_table[SND_##name] = fpk_address(resource, fname, NULL); }
#include "sound.h"
#undef SOUND_
#undef SOUND_RESOURCE_
	}
#endif /*USE_SOUND*/

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#define TEXTURE_RESOURCE_(name,fname) const void* const name = fpk_address(resource, fname, NULL);
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#define TEXTURE_RESOURCE_(name,fname) name,
#include "texture.h"
#undef TEXTURE_
#undef TEXTURE_RESOURCE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

#ifdef USE_VIDREC
	/* ʏo͂܂B */
	yield(); /* runŎsꍇ̎smFɉ邽߁AUSB@\̐؂ւ͂ɒx点 */
#ifdef LDIRECT_INTERVAL
	cdcacm_start(0, sizeof vbuff / 2, NULL, NULL);
#else /*LDIRECT_INTERVAL*/
	cdcacm_start(0, sizeof vbuff / 4, NULL, NULL);
#endif /*LDIRECT_INTERVAL*/
#endif /*USE_VIDREC*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
/*{{AvP[VL̃N[Abv*/
	/** no job **/
/*}}AvP[VL̃N[Abv*/

#ifdef USE_VIDREC
	/* ʏo͂I܂B */
	cdcacm_stop();
#endif /*USE_VIDREC*/

#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_DBG
	/* DBGjbg̐ݒ܂B */
	dbg_free();
#endif /*USE_DBG*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	update
 ****************************************************************************/

/* * Mon Nov 06 17:37:17 JST 2006 Naoyuki Sawa
 * - schedule()AʍXV𕪗܂B
 *   t[҂ʍXVsꍇ́Å֐ĂяoĂB
 */
void
update()
{
#ifdef V_SCREEN
	/* vbuff(c)_def_vbuff()ϊ */
	unsigned char *dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
	unsigned char *src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
	int x, y;
	for(x = DISP_X - 1; x >= 0; x--) {
		for(y = 0; y < DISP_Y; y++) {
			*dst = *src;
			dst += 1;      /* ʂEɑ܂ */
			src += DISP_X; /* cʂɑ܂ */
		}
		                            /* ʂ͊Ɏ̍sֈړĂ܂ */
		src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
	}
#endif /*V_SCREEN*/

	/* ʓ] */
	pceLCDTrans();
}

/****************************************************************************
 *	vidrec
 ****************************************************************************/

#ifdef USE_VIDREC
static void
vidrec()
{
#ifdef LDIRECT_INTERVAL
	static const unsigned char hdr[4] = { DISP_X,DISP_Y,4/*[bpp]*/,FPS };
#else /*LDIRECT_INTERVAL*/
	static const unsigned char hdr[4] = { DISP_X,DISP_Y,2/*[bpp]*/,FPS };
#endif /*LDIRECT_INTERVAL*/
	static int active;
	//
	unsigned char buf[128/**/]; /* (sizeof vbuff)/ÑTCYƂ邱 */
	const unsigned char* src;
	unsigned char* dst;

	if(cdcacm_recv(buf, 1) > 0) {
		switch(buf[0]) {
		case 0:
			active = 0; /* ʏo͒~ */
			break;
		case 1:
			active = 1; /* ʏo͊Jn */
			src = hdr;
			do {
				if(pcePadGetDirect() & PAD_SELECT) {
					exit(0); /* M҂Ɋ荞ŋI */
				}
				src += cdcacm_send(src, &hdr[sizeof hdr] - src);
			} while(src < &hdr[sizeof hdr]);
			break;
		}
	}
	if(active) {
		src = vbuff;
		do {
			dst = buf;
			do {
#ifdef LDIRECT_INTERVAL
				*dst++ = src[0]|(src[1]<<4); 
				src += 2;
#else /*LDIRECT_INTERVAL*/
				*dst++ = src[0]|(src[1]<<2)|(src[2]<<4)|(src[3]<<6);
				src += 4;
#endif /*LDIRECT_INTERVAL*/
			} while(dst < &buf[sizeof buf]);
			dst = buf;
			do {
				if(pcePadGetDirect() & PAD_SELECT) {
					exit(0); /* M҂Ɋ荞ŋI */
				}
				dst += cdcacm_send(dst, &buf[sizeof buf] - dst);
			} while(dst < &buf[sizeof buf]);
		} while(src < &vbuff[sizeof vbuff]);
	}
}
#endif /*USE_VIDREC*/

/****************************************************************************
 *	schedule
 ****************************************************************************/

/* * Fri Dec 15 00:49:15 JST 2006 Naoyuki Sawa
 * - schedule()֐ɁATEh|[YΉR[hǉ܂B
 *   ł͏肭삵Ă悤łAX[v̕Aɖ肪NȂmFłB
 * - A|[YԂ̂܂܁AȂ킿ATEh|[YԂ̂܂܂ŃAvP[VIĂ܂ꍇɂA
 *   CLiPCupceAppExit()pceWaveStop(1)ĂяoĂATEhԂZbĝŁAvłB
 */

void
schedule()
{
#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		/*{{2006/12/15:TEh|[YΉ*/
		int sound_pause = 0/*x}*/;
		/*}}2006/12/15:TEh|[YΉ*/
		int x, y;
		for(;;) {
#endif /*USE_PAUSE*/
			/* ʍXVB */
			update();
#ifdef USE_VIDREC
			/* ʏóB */
			vidrec();
#endif /*USE_VIDREC*/
			/* VXeB */
			yield();
			/* pbhԍXVB */
			joy = pad_get();
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					sound_pause = fINT_EDMA.EHDM1;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 0;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/*{{2006/12/15:TEh|[YΉ*/
					ENTER_CS;
					if(sound_pause) {
						fINT_EDMA.EHDM1 = 1;
					}
					LEAVE_CS;
					/*}}2006/12/15:TEh|[YΉ*/
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE*/

	if(joy & TRG_SELECT) {
		exit(0);
	}

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

/*{{sX^bN*/
static matf mat_stack[16];
static matf* mat_ptr = mat_stack;
void mat_push() {
	if(mat_ptr >= &mat_stack[15]) DIE();
	mat_ptr++;
	mat_ptr[0] = mat_ptr[-1];
}
void mat_pop() {
	if(mat_ptr <= &mat_stack[0]) DIE();
	mat_ptr--;
}
void mat_load() {
	matx_conv(&render.context->matrix, mat_ptr);
}
void mat_get() {
	matf_conv(mat_ptr, &render.context->matrix);
}
/*}}sX^bN*/

void matf_rotzxy(matf* mat, float ang1, float ang2, float ang3) {
	float c1 = cosf(ang1), s1 = sinf(ang1);
	float c2 = cosf(ang2), s2 = sinf(ang2);
	float c3 = cosf(ang3), s3 = sinf(ang3);
	matf tmp = {
		(c1 *  c3) + (s1 * s2 * s3), (-s1 *  c3) + (c1 * s2 * s3), ( c2 * s3), 0.0f,
		             (s1 * c2     ),               (c1 * c2     ), (-s2     ), 0.0f,
		(c1 * -s3) + (s1 * s2 * c3), (-s1 * -s3) + (c1 * s2 * c3), ( c2 * c3), 0.0f,
	};
	matf_xform(mat, &tmp);
}

/*--------------------------------------------------------------------------*/

extern const MESH MESH_FLOOR;
extern const MESH MESH_COMPUTER;
extern const MESH MESH_KEYBOARD;
extern const MESH MESH_KEY_X;
extern const MESH MESH_KEY_Y;
extern const MESH MESH_KEY_Z;
extern const MESH MESH_KEY_H;
extern const MESH MESH_KEY_R;
extern const MESH MESH_KEY_D;
extern const MESH MESH_BOARD;
extern const MESH MESH_FONT_H;
extern const MESH MESH_FONT_A;
extern const MESH MESH_FONT_L;

unsigned char bgbuff[DISP_X * DISP_Y];

const MESH* const key_mesh[6] = {
	&MESH_KEY_X,&MESH_KEY_Y,&MESH_KEY_Z,
	&MESH_KEY_H,&MESH_KEY_R,&MESH_KEY_D,
};
const float key_pos[6][2] = {
	{ -0.6f, 0.3f }, { 0.0f, 0.3f },{ 0.6f, 0.3f },
	{ -0.6f,-0.3f }, { 0.0f,-0.3f },{ 0.6f,-0.3f },
};

const MESH* const font_mesh[3] = {
	&MESH_FONT_H,&MESH_FONT_A,&MESH_FONT_L,
};
float font_pos[3][3/*x,y,vy*/] = {
	{ 1.75f-0.75f, 0.0f, 0.0f },
	{ 1.75f      , 0.0f, 0.0f },
	{ 1.75f+0.75f, 0.0f, 0.0f },
};

#define VIEW_Y		10
#define VIEW_H		68
#undef FRONT
#undef BACK
#undef FOVY
#define FRONT		 0.5f
#define BACK		25.0f
#define FOVY		(float)(M_PI * 45.0f / 180.0f)

int loop;
int step;

#define computer_x	-1.5f
#define computer_y	 2.0f
#define computer_z	 0.25f
float computer_rotx;
float computer_roty;
float computer_rotz;

#define keyboard_x	 1.5f
#define keyboard_y	 0.0f
#define keyboard_z	-2.5f
int key_sel;
int key_cnt;

#define board_x		1.75f
#define board_y		2.25f
#define board_z		1.5f

float font_a_roty;
float font_l_rotz;

static void
bg_init()
{
	int x;
	int y;

	render_init_2d(&render, &surface, 0, 0, 0, 0);

	render.context->texture = &texture_table[TEX_TTL];
	render_object(&render, 0, 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);
	for(x = 0; x < FSEC(4,10); x++) {
		schedule();
		if(x >= SEC(0.5)) {
			if(joy & TRG_AB) {
				break;
			}
		}
	}
	surface_clear(&surface, 3);
	delay(SEC(0.3));

//{{2008/04/06:ǉ
// * Sun Apr 06 22:46:42 JST 2008 Naoyuki Sawa
// - ɂ30FPSȏo悤ɂȂ̂ŁA30FPS̃~b^O܂B
//   ŏOĂ܂ƁA^CgʂuŏIĂ܂̂ŁA
//   ȂȂ悤A^Cgʕ\Ƀ~b^OƂɂ܂B
	pceAppSetProcPeriod(1);
//}}2008/04/06:ǉ

	for(y = 0; y < DISP_Y; y++) {
		for(x = 0; x < DISP_X; x++) {
			render_point(&render, x, y, (x ^ y) & 1 ? 2 : 3);
		}
	}
	render.context->texture = &texture_table[TEX_PAT];
	render_object(&render, 0,               0, 0, 224, DISP_X, VIEW_Y, DRW_NOMAL);
	render_object(&render, 0, DISP_Y - VIEW_Y, 0, 240, DISP_X, VIEW_Y, DRW_NOMAL);
	memcpy(bgbuff, vbuff, DISP_X * DISP_Y);

//{{ǂłB҂ׂ̕ĕ_ZȂ̂ŁA덷łB
#if 0
	render_init_3d(&render, &surface, 0, VIEW_Y, DISP_X, VIEW_H, fld(FRONT), fld(BACK), fld(FOVY));
	mat_get();
#else
	render_init_3d(&render, &surface, 0, VIEW_Y, DISP_X, VIEW_H, fld(FRONT), fld(BACK), fld(FOVY));
	*mat_ptr = matf_1;
	matf_viewportz(mat_ptr, 0, VIEW_Y, DISP_X, VIEW_H);
	matf_perspect(mat_ptr, FOVY, (float)(DISP_X) / (float)(VIEW_H), FRONT);
#endif
}

typedef struct _LOOKAT {
	int step;
	float v[6];
} LOOKAT;

const LOOKAT lookat_tbl[/*MAX_LOOKAT*/] = {
	{ FSEC( 6,25)-FSEC(4,10), {  0.00f, 2.00f,-6.00f,  0.00f, 0.00f, 3.00f } },	/* (~) */
	{ FSEC( 7,25)-FSEC(4,10), {  0.00f, 1.00f,-5.50f,  0.00f, 0.90f,-0.50f } },	/* ~ */
	{ FSEC( 8,10)-FSEC(4,10), {  0.00f, 0.50f,-3.00f,  0.00f, 0.40f, 3.00f } },	/* Oi */
	{ FSEC( 9,05)-FSEC(4,10), {  1.00f, 0.50f,-0.50f,  1.75f, 0.50f, 1.50f } },	/* HAL */
	{ FSEC( 9,15)-FSEC(4,10), {  1.00f, 0.50f,-0.50f,  1.75f, 0.50f, 1.50f } },	/* HAL(~) */
	{ FSEC(10,00)-FSEC(4,10), {  1.00f, 0.50f,-0.50f,  1.75f, 2.75f, 1.50f } },	/* グ */
	{ FSEC(10,15)-FSEC(4,10), {  1.00f, 0.50f,-0.50f,  1.75f, 2.75f, 1.50f } },	/* グ(~) */
	{ FSEC(11,10)-FSEC(4,10), {  1.00f, 0.50f,-0.50f,  1.75f, 0.50f, 1.50f } },	/* HAL */
	{ FSEC(12,20)-FSEC(4,10), {  1.00f, 0.50f,-0.50f,  1.75f, 0.50f, 1.50f } },	/* HAL(~) */
	{ FSEC(13,05)-FSEC(4,10), {  1.00f, 0.50f,-0.50f,  1.75f, 2.75f, 1.50f } },	/* グ */
	{ FSEC(13,15)-FSEC(4,10), {  1.00f, 0.50f,-0.50f, -1.50f, 2.00f, 0.25f } },	/* Rs[^ */
	{ FSEC(13,25)-FSEC(4,10), {  1.00f, 0.50f,-0.50f,  1.50f, 0.50f,-2.50f } },	/* L[{[h */
	{ FSEC(15,00)-FSEC(4,10), { -1.00f, 7.50f, 4.00f,  0.00f, 0.00f, 0.50f } },	/* ] */
};
#define MAX_LOOKAT	ARRAY_SIZE(lookat_tbl)

void
get_lookat(LOOKAT* lookat)
{
	int i;
	int j;
	float t;

	if(lookat->step < lookat_tbl[0].step) {
		*lookat = lookat_tbl[0];
		return;
	}

	for(i = 0; i < MAX_LOOKAT; i++) {
		if(lookat->step < lookat_tbl[i].step) {
			break;
		}
	}

	if(i == 0) {
		*lookat = lookat_tbl[0];
		return;
	}
	if(i == MAX_LOOKAT) {
		*lookat = lookat_tbl[MAX_LOOKAT - 1];
		return;
	}

	t = (float)(      lookat->step - lookat_tbl[i - 1].step)
	  / (float)(lookat_tbl[i].step - lookat_tbl[i - 1].step);
	for(j = 0; j < 6; j++) {
		lookat->v[j] =                       lookat_tbl[i - 1].v[j]
		             + (lookat_tbl[i].v[j] - lookat_tbl[i - 1].v[j]) * t;
	}
}

typedef struct _POS {
	int step;
	float v[3];
} POS;

const POS board_tbl[/*MAX_BOARD*/] = {
	{ FSEC( 5,25)-FSEC(4,10), { board_x, board_y, board_z } },	/* (~) */
	{ FSEC( 7,00)-FSEC(4,10), {    7.0f, board_y, board_z } },	/*  */
	{ FSEC( 9,14)-FSEC(4,10), {    7.0f, board_y, board_z } },
	{ FSEC( 9,15)-FSEC(4,10), { board_x,    0.0f, board_z } },	/* グJn */
	{ FSEC(10,00)-FSEC(4,10), { board_x, board_y, board_z } },	/* グ */
	{ FSEC(10,10)-FSEC(4,10), { board_x, board_y, board_z } },
	{ FSEC(11,15)-FSEC(4,10), {    7.0f, board_y, board_z } },	/*  */
	{ FSEC(12,19)-FSEC(4,10), {    7.0f, board_y, board_z } },
	{ FSEC(12,20)-FSEC(4,10), { board_x,    0.0f, board_z } },	/* グJn */
	{ FSEC(13,05)-FSEC(4,10), { board_x, board_y, board_z } },	/* グ */
	{ FSEC(13,15)-FSEC(4,10), { board_x, board_y, board_z } },
	{ FSEC(14,20)-FSEC(4,10), {    7.0f, board_y, board_z } },	/*  */
};
#define MAX_BOARD	ARRAY_SIZE(board_tbl)

void
get_board(POS* pos)
{
	int i;
	int j;
	float t;

	if(pos->step < board_tbl[0].step) {
		*pos = board_tbl[0];
		return;
	}

	for(i = 0; i < MAX_BOARD; i++) {
		if(pos->step < board_tbl[i].step) {
			break;
		}
	}

	if(i == 0) {
		*pos = board_tbl[0];
		return;
	}
	if(i == MAX_BOARD) {
		*pos = board_tbl[MAX_BOARD - 1];
		return;
	}

	t = (float)(        pos->step - board_tbl[i - 1].step)
	  / (float)(board_tbl[i].step - board_tbl[i - 1].step);
	for(j = 0; j < 3; j++) {
		pos->v[j] = (                        board_tbl[i - 1].v[j])
		          + (board_tbl[i    ].v[j] - board_tbl[i - 1].v[j]) * t;
	}
}

void
app_main()
{
	int frame = 0;
	int T0 = 0;
	int dT = 0;
	//
	int i;
	int j;
	LOOKAT lookat;
	POS board;

	bg_init();

	T0 = pceTimerGetCount();
	for(;;) {
		schedule();
		memcpy(vbuff, bgbuff, DISP_X * DISP_Y);
		memset(zbuff, -1, DISP_X * DISP_Y);

		mat_push();

			lookat.step = step;
			get_lookat(&lookat);
			matf_lookat(mat_ptr, (vecf*)&lookat.v[0], (vecf*)&lookat.v[3], 0.0f);

			render.context->texture = NULL;
			mat_load();
			render_mesh(&render, &MESH_FLOOR);
			memset(zbuff, -1, DISP_X * DISP_Y);

			/* Rs[^ */
			mat_push();
				render.context->texture = &texture_table[TEX_PAT];
				matf_xlate(mat_ptr, computer_x, computer_y, computer_z);
				matf_rotzxy(mat_ptr, computer_rotz, computer_rotx, computer_roty);
				mat_load();
				render_mesh(&render, &MESH_COMPUTER);
			mat_pop();

			/* Rs[^̉e */
			mat_push();
				render.context->texture = NULL;
				matf_xlate(mat_ptr, computer_x, 0.0f, computer_z);
				matf_scale(mat_ptr, 1.0f, 0.0f, 1.0f);
				matf_rotzxy(mat_ptr, computer_rotz, computer_rotx, computer_roty);
				mat_load();
				render_mesh(&render, &MESH_COMPUTER);
			mat_pop();

			/* Rs[^] */
			if(loop || (step >= SEC(0.5))) {
				computer_roty += (float)(M_PI2 * 0.009f);
				computer_roty = fmodf(computer_roty, (float)M_PI2);
			}
			if(loop || (step >= SEC(1.0))) {
				computer_rotx -= (float)(M_PI2 * 0.006f);
				computer_rotx = fmodf(computer_rotx, (float)M_PI2);
			}
			if(loop || (step >= SEC(1.5))) {
				computer_rotz += (float)(M_PI2 * 0.004f);
				computer_rotz = fmodf(computer_rotz, (float)M_PI2);
			}

			/* L[{[h */
			mat_push();
				render.context->texture = NULL;
				matf_xlate(mat_ptr, keyboard_x, keyboard_y, keyboard_z);
				mat_load();
				render_mesh(&render, &MESH_KEYBOARD);

				/* L[ */
				mat_push();
					render.context->texture = &texture_table[TEX_PAT];
					matf_xlate(mat_ptr, 0.0f, 0.42f, -0.03f);
					matf_rotx(mat_ptr, (float)(-M_PI2 / 24.0f));
					for(i = 0; i < 6; i++) {
						mat_push();
							if((key_sel == i) && (key_cnt >= SEC(0.1))) {
								matf_xlate(mat_ptr, key_pos[i][0], -0.1f, key_pos[i][1]);
							} else {
								matf_xlate(mat_ptr, key_pos[i][0],  0.0f, key_pos[i][1]);
							}
							mat_load();
							render_mesh(&render, key_mesh[i]);
						mat_pop();
					}
				mat_pop();
			mat_pop();

			/* L[^CsO */
			key_cnt++;
			if(key_cnt >= SEC(0.2)) {
				key_cnt = 0;
				key_sel = RND32_RANGE(seed, 0, 6);
			}

			/* |[h */
			board.step = step;
			get_board(&board);
			render.context->texture = NULL;
			if(board.v[1] < 7.0f) {
				mat_push();
					matf_xlate(mat_ptr, board.v[0], board.v[1], board.v[2]);
					mat_load();
					render_mesh(&render, &MESH_BOARD);
				mat_pop();
			}
			if(board.v[1] == board_y) {
				mat_push();
					matf_xlate(mat_ptr, board_x, 0.0f, board_z);
					mat_load();
					render_mesh(&render, &MESH_BOARD);
				mat_pop();
			}

			/* HAL */
			for(i = 0; i < 3; i++) {
				if(font_pos[i][0] >= (board.v[0] - 1.0f)) {
					font_pos[i][1] = board.v[1];
					font_pos[i][2] = 0.0f;
					if(i == 2) { /* L */
						font_l_rotz = 0.0f;
					}
				} else {
					font_pos[i][2] -= 0.03f;
					font_pos[i][1] += font_pos[i][2];
					if(i == 2) { /* L */
						font_l_rotz -= (float)(M_PI2 * 0.0125f);
					}
					if(font_pos[i][1] < 0.0f) {
						font_pos[i][1] = -font_pos[i][1];
						font_pos[i][2] = -font_pos[i][2];
						font_pos[i][2] *= 0.6f;
						if(font_pos[i][2] < 0.06f) {
							font_pos[i][2] = 0.0f;
						}
						if(i == 2) { /* L */
							font_l_rotz = 0.0f;
						}
					}
				}
				mat_push();
					matf_xlate(mat_ptr, font_pos[i][0], (font_pos[i][1] + 0.375f), board_z);
					switch(i) {
					case 1: /* A */
						if(loop || (step >= (FSEC(5,20)-FSEC(4,10)))) {
							font_a_roty += (float)(M_PI2 * 0.025f);
							font_a_roty = fmodf(font_a_roty, (float)M_PI2);
						}
						matf_roty(mat_ptr, font_a_roty);
						break;
					case 2: /* L */
						matf_rotz(mat_ptr, font_l_rotz);
						break;
					}
					mat_load();
					render_mesh(&render, font_mesh[i]);
				mat_pop();
			}

			/* ڂ͎ct[\Aڈȍ~͈ڂɌvt[[g\B */
			j = render.bottom;
			render.bottom = DISP_Y;
			if(!loop) {
				frame++;
				i = (FSEC(15,10)-FSEC(4,10)) - frame;
				render_printf(&render, 114, 81, 0x82, 0, "%3d", i);
				dT = pceTimerGetCount() - T0;
			} else {
				i = frame * (1000 * 10) / dT;
				if(i > 999) {
					i = 999;
				}
				render_printf(&render, 112, 81, 0x82, 0, "%2d", i / 10);
				render_point(&render, 120, 85, 0);
				render_printf(&render, 122, 81, 0x82, 0, "%d", i % 10);
			}
			render.bottom = j;

			/* isA[vB */
			step++;
			if(step >= FSEC(15,10)-FSEC(4,10)) {
				step = 0;
				loop++;
			}

		mat_pop();
	}
}
